unit hiSymbolsGen;

interface

uses Kol,Share,Debug;

type
  THISymbolsGen = class(TDebug)
   private
    Result: string;
   public
    _prop_Count:integer;
    _prop_Symbols:string;

    _event_onResult:THI_Event;
    _data_Count:THI_Event;
    _data_Symbols:THI_Event;

    constructor Create;
    procedure _work_doRandomize(var _Data:TData; Index:word);
    procedure _work_doGenerate(var _Data:TData; Index:word);
    procedure _var_Result(var _Data:TData; Index:word);
  end;

implementation


constructor THISymbolsGen.Create;
begin
  Randomize;
end;

procedure THISymbolsGen._work_doRandomize;
begin
  Randomize;
end;

procedure THISymbolsGen._work_doGenerate;
const StrTable: string ='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz-.';
var
  N, K, X, Y,PWLen: integer;
begin
  StrTable:=ReadString(_Data,_data_Symbols,_prop_Symbols);
  PWLen:=ReadInteger(_Data,_data_Count,_prop_Count);
  if (PWlen > Length(StrTable)) then K := Length(StrTable)-1
    else K := PWLen;
  SetLength(result, K);
  Y := Length(StrTable); 
  N := 0;  
  while N < K do begin  
    X := Random(Y) + 1;   
    if (pos(StrTable[X], result) = 0) then begin
      inc(N);   
      Result[N] := StrTable[X]; 
    end;
  end;
  _hi_onEvent(_event_onResult,Result);
end;

procedure THISymbolsGen._var_Result;
begin
  _Data.data_type:=data_str;
  _Data.sdata:=Result;
end;

end.
